;
; ------------------------------------------------------------
;
;   PureBasic - Network (Server) example file
;
;    (c) 2003 - Fantaisie Software
;
; ------------------------------------------------------------
;

If InitNetwork() = 0 Or InitSound()=0
  MessageRequester("Error", "Can't initialize the network !", 0)
  End
EndIf

Enumeration
  #Gdt_Panel
  
  #Gdt_Search_Txt
  #Gdt_Search
  #Gdt_QuestionList
  #Gdt_EditQuestion_text
  #Gdt_EditQuestion
  #Gdt_EditAnswer_Txt
  #Gdt_EditAnswer
  #Gdt_EditFullAnswer_Txt
  #Gdt_EditFullAnswer
  #Gdt_EditCheckLink_Txt
  #Gdt_EditCheckLink
  #Gdt_Add
  #Gdt_ResetCounter
  #Gdt_EditCounter
  #Gdt_Save
  #Gdt_ImportDB
  #Gdt_ExportDB
  #Gdt_Category
  #Gdt_File
  #Gdt_FileAdd
  #Gdt_FileRemove
  
EndEnumeration

#Snd_Question=1 ;Pour le son !

UseJPEGImageDecoder() 
UseJPEG2000ImageDecoder() 
UsePNGImageDecoder() 
UseOGGSoundDecoder()
Global Dim Category2GadgetState.l(100)
IncludeFile("Database.pbi")




OpenQuizDB()
Procedure.s stripretcode(txt.s)
	txt = ReplaceString(txt, Chr(13), "")
	txt = ReplaceString(txt, Chr(10),"")
	ProcedureReturn txt
EndProcedure


Procedure RefreshQuestionList(SelectedId.l=-1)
  ClearGadgetItems(#Gdt_QuestionList)

	Protected Sql.s,n.l, Col.l
	Protected Id.l,Question.s,Counter.l,Success.l,Missed.l
	Sql.s = "SELECT Id,Question,Counter,Success,Missed FROM Question ORDER BY Id Desc"
	If IsDatabase(#Db)
		n.l = -1;
		If DatabaseQuery(#Db, Sql)
			While NextDatabaseRow(#Db) ; Enumeration des enregistrements
				n + 1;
				For Col = 0 To DatabaseColumns(#Db)
					Select DatabaseColumnName(#Db, Col)
						Case "Id"
							Id = GetDatabaseLong(#Db, Col)
						Case "Question"
							Question = stripslashes(GetDatabaseString(#Db, Col))
						Case "Counter"
							Counter = GetDatabaseLong(#Db, Col)
							Case "Success"
							Success = GetDatabaseLong(#Db, Col)
						Case "Missed"
							Missed = GetDatabaseLong(#Db, Col)
					EndSelect
				Next
				
				AddGadgetItem(#Gdt_QuestionList, n, Str(Id)+Chr(10)+stripretcode(Question)+Chr(10)+Str(Counter)+Chr(10)+Str(Success)+Chr(10)+Str(Missed))
				SetGadgetItemData(#Gdt_QuestionList, n, Id)
				If Id=SelectedId
				  SetGadgetState(#Gdt_QuestionList,n)
				  Debug "selection"
				EndIf
			Wend
			FinishDatabaseQuery(#Db)
		EndIf
	EndIf
EndProcedure

Procedure SetCategory(Id)

EndProcedure


Procedure RefreshEditQuestion()
  Protected Sql.s,n.l, Col.l
	Protected Id.l,Question.s,Counter.s,Id_Category.l
	Sql.s = "SELECT Id,Id_Category,Question,Answer,FullAnswer,CheckLink,Counter FROM Question Where Id='"+Str(GetGadgetItemData(#Gdt_QuestionList, GetGadgetState(#Gdt_QuestionList)))+"'"
	If IsDatabase(#Db)
		If DatabaseQuery(#Db, Sql)
			While NextDatabaseRow(#Db) ; Enumeration des enregistrements
				Id = GetDatabaseLong(#Db, 0)
				Id_Category.l =GetDatabaseLong(#Db, 1)
				Question = GetDatabaseString(#Db, 2)
        Answer.s = GetDatabaseString(#Db, 3)
        FullAnswer.s = GetDatabaseString(#Db, 4)
        CheckLink.s = GetDatabaseString(#Db, 5)
				SetGadgetText(#Gdt_EditQuestion,stripslashes(Question))
				SetGadgetText(#Gdt_EditAnswer,stripslashes(Answer))
				SetGadgetState(#Gdt_Category,Category2GadgetState(Id_Category))
				SetGadgetText(#Gdt_EditFullAnswer,stripslashes(FullAnswer))
				SetGadgetText(#Gdt_EditCheckLink,stripslashes(CheckLink))
				LoadFileFromDb(Id,1)
				If IsSound(#Snd_Question)
				  CatchImage(1,?SoundImage)
				EndIf
				
				If IsImage(1)
  				ResizeImage(1,250,250)
  				SetGadgetState(#Gdt_File,ImageID(1))
  				;StartDrawing(WindowOutput(0))
  				;  DrawAlphaImage(ImageID(1),320,200)
  				;StopDrawing()
				Else
  				CreateImage(0,250,250)
  				SetGadgetState(#Gdt_File,ImageID(0))
				EndIf
			Wend
			FinishDatabaseQuery(#Db)
		EndIf
	EndIf
EndProcedure


Procedure Update_Counter(n.l=0,Id.l=0)
  Sql.s = "Update Question SET Counter='"+Str(n)+"'"
  If Id>0
    Sql+" Where Id='"+Str(Id)+"'";
  EndIf
  Debug Sql
  If IsDatabase(#Db)
		If DatabaseUpdate(#Db, Sql)
		  ;FinishDatabaseQuery(#Db)
		Else
			DbError(Sql.s)
		EndIf
  EndIf
EndProcedure


Procedure RefreshEditCategory()
  Protected Sql.s,n.l, Col.l
	Protected Id.l,Question.s,Counter.s
	Sql.s = "SELECT Id,Category FROM Category ORDER BY Category"
	ClearGadgetItems(#Gdt_Category)
	If IsDatabase(#Db)
		n.l = -1;
		If DatabaseQuery(#Db, Sql)
			While NextDatabaseRow(#Db) ; Enumeration des enregistrements
				n + 1;
				For Col = 0 To DatabaseColumns(#Db)
					Select DatabaseColumnName(#Db, Col)
						Case "Id"
							Id = GetDatabaseLong(#Db, Col)
						Case "Category"
							Category.s = GetDatabaseString(#Db, Col)
					EndSelect
				Next
				AddGadgetItem(#Gdt_Category, n, Category)
				SetGadgetItemData(#Gdt_Category, n, Id)
				Category2GadgetState(Id)=n
			Wend
			FinishDatabaseQuery(#Db)
		EndIf
	EndIf
EndProcedure

Macro AddGadgetText(Gdt,txt,Taille)
TextGadget(Gdt-1,GadgetX(Gdt),GadgetY(Gdt)+2,Taille,GadgetHeight(Gdt),txt):ResizeGadget(Gdt,GadgetX(Gdt)+Taille,#PB_Ignore,GadgetWidth(Gdt)-Taille,#PB_Ignore)
EndMacro

  CreateImage(1,64,64)
  ;MessageRequester("PureBasic - Server", "Server created (Port "+Str(Port)+").", 0)
  OpenWindow(0, 0, 0, 800, 600, "Extrem Brain Quizz Server",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
  ;StickyWindow(0, 1) 
  PanelGadget (#Gdt_Panel, 5, 5, 790, 580)
  AddGadgetItem(#Gdt_Panel, -1, "Database")
    TextGadget(#Gdt_Search_Txt,5,5,60,20,"Rechercher")
    StringGadget(#Gdt_Search,65,5,350,20,"")
    ListIconGadget(#Gdt_QuestionList, 5, 30, 610, 200, "Id", 40,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)
    AddGadgetColumn(#Gdt_QuestionList,1,"Question",400)
    AddGadgetColumn(#Gdt_QuestionList,2,"Compter",60)
    AddGadgetColumn(#Gdt_QuestionList,3,"Success",60)
    AddGadgetColumn(#Gdt_QuestionList,4,"Missed",50)
    EditorGadget(#Gdt_EditQuestion, 5, 240, 450, 60):AddGadgetText(#Gdt_EditQuestion,"Question",60)
    ComboBoxGadget(#Gdt_Category,460,240,250,20,#PB_ComboBox_Editable):AddGadgetText(#Gdt_Category,"Categorie",60)
    ImageGadget(#Gdt_File,  460,265, 250, 250, ImageID(1))
    ButtonGadget(#Gdt_FileAdd,460,512,150,20,"AddFile")
    ButtonGadget(#Gdt_FileRemove,610,512,150,20,"RemoveFile")
    StringGadget(#Gdt_EditAnswer,5,305,450,20,""):AddGadgetText(#Gdt_EditAnswer,"Reponse",60)
    EditorGadget(#Gdt_EditFullAnswer,5,330,450,70):AddGadgetText(#Gdt_EditFullAnswer,"Reponse Complete",100)
    StringGadget(#Gdt_EditCheckLink,5,405,450,20,""):AddGadgetText(#Gdt_EditCheckLink,"Lien Http",60)
    ButtonGadget(#Gdt_Add, 450, 5, 70, 20, "Add Question")
    ButtonGadget(#Gdt_ResetCounter, 520, 5, 70, 20, "Reset Counter")
    ButtonGadget(#Gdt_ImportDB, 620, 30, 150, 20, "ImportDB")
    ButtonGadget(#Gdt_ExportDB, 620, 55, 150, 20, "ExportDB")
    ButtonGadget(#Gdt_EditCounter,620,80,150,20,"Counter+1")
    ButtonGadget(#Gdt_Save, 5, 450, 100, 20, "Save")
    RefreshEditCategory()
  RefreshQuestionList()
  Repeat
    Repeat
			Event=WindowEvent()
			Select Event
			  Case #PB_Event_Gadget
			    Select EventGadget()
            Case #Gdt_QuestionList
              RefreshEditQuestion()
            Case #Gdt_Save
              UpdateQuestion(GetGadgetItemData(#Gdt_QuestionList, GetGadgetState(#Gdt_QuestionList)),GetGadgetText(#Gdt_EditQuestion),GetGadgetText(#Gdt_EditAnswer),GetGadgetText(#Gdt_EditFullAnswer),GetGadgetText(#Gdt_EditCheckLink),20,AddCategory(GetGadgetText(#Gdt_Category)))
              RefreshEditCategory()
              RefreshQuestionList()
            Case #Gdt_Add
              Id=AddQuestion(1,"",20,"","","")
              RefreshQuestionList(Id)
              RefreshEditQuestion()
              RefreshQuestionList()
            Case #Gdt_ResetCounter
              Update_Counter(0)
              RefreshQuestionList()
            Case #Gdt_ImportDB
              If MessageRequester("Question :", "Voulez-Vous craser la base de donne Actuel", #PB_MessageRequester_YesNo)=#PB_MessageRequester_Yes 
                Del.b=#True
              Else
                Del.b=#False
              EndIf
              File$ = OpenFileRequester("Please choose file import", "quiz.csv", "*.csv", 0)
              If File$
                ImportCsv(File$,Del)
                RefreshQuestionList()
              Else
                MessageRequester("Information", "The requester was canceled.", 0) 
              EndIf
              RefreshQuestionList()
            Case #Gdt_ExportDB
            Debug"Export"
              ExportCSV()
            Case #Gdt_Category
              Debug EventType()
              If EventType()=#PB_EventType_LostFocus
                Debug GetGadgetItemData(#Gdt_Category,GetGadgetState(#Gdt_Category))
                ;AddCategory(Category.s)
                ;RefreshEditCategory()
              EndIf
            Case #Gdt_FileAdd
              File$ = OpenFileRequester("Please choose image(Png/Jpeg) or Sound (ogg)", "", "Images (jpg/png)|*.jpg;*.jpeg;*.png|Sounds (ogg)|*.ogg|All files (*.*)|*.*", 0)
              If File$
                Id=GetGadgetItemData(#Gdt_QuestionList, GetGadgetState(#Gdt_QuestionList))
                UpdateFileToDb(Id,File$)
                LoadFileFromDb(Id,1)
        				If IsImage(1)
          				ResizeImage(1,64,64)
          				SetGadgetState(#Gdt_File,ImageID(1))
        				Else
          				CreateImage(0,64,64)
          				SetGadgetState(#Gdt_File,ImageID(0))
        				EndIf
                
              Else
                MessageRequester("Information", "The requester was canceled.", 0)
                LoadFileFromDb(Id,1)
        				If IsImage(1)
          				ResizeImage(1,64,64)
          				SetGadgetState(#Gdt_File,ImageID(1))
        				Else
          				CreateImage(0,64,64)
          				SetGadgetState(#Gdt_File,ImageID(0))
        				EndIf
              EndIf
              RefreshQuestionList()
            Case #Gdt_FileRemove
               Id=GetGadgetItemData(#Gdt_QuestionList, GetGadgetState(#Gdt_QuestionList))
               UpdateFileToDb(Id,"")
            Case #Gdt_EditCounter
              Id=GetGadgetItemData(#Gdt_QuestionList, GetGadgetState(#Gdt_QuestionList))
             Update_Counter(1,Id)
             RefreshQuestionList(Id)
            Case #Gdt_File
              If IsSound(#Snd_Question)
                PlaySound(#Snd_Question)
              EndIf
          EndSelect
				Case #PB_Event_CloseWindow
					End
			EndSelect
		Until Event=0
    
    
    
    
  Until Quit = 1 




DataSection
    SoundImage:
    IncludeBinary "sound.png"
EndDataSection

; IDE Options = PureBasic 4.40 Beta 6 (Windows - x86)
; CursorPosition = 288
; FirstLine = 244
; Folding = --
; EnableXP